<?php
\CastPlugin\CpCore::loadVue();
wp_enqueue_script('cpotp-process-login');
?>
<div class="wrap">
    <h1 class="wp-heading-inline">
        <?php _cp('Smart OTP - Setting Page'); ?>
    </h1>
    <div id="appCpOTP">
        <el-form v-loading="loading" method="post" ref="form" :model="form" label-width="200px"
                 @submit.native.prevent="saveForm($event)">
            <el-tabs :style="styling_tab_header" v-model="tabActive" type="border-card" tab-position="left">


                <el-tab-pane label="General" name="general">

                    <el-form-item label="Facebook App ID">
                        <el-input v-model="form.app_id"></el-input>
                    </el-form-item>

                    <el-form-item label="Facebook App Secret">
                        <el-input v-model="form.app_secret"></el-input>
                    </el-form-item>

                    <el-form-item label="Facebook App Version">
                        <el-input v-model="form.app_version"></el-input>
                    </el-form-item>

                    <el-form-item label="Display As">
                        <el-radio-group v-model="form.app_display">
                            <el-radio label="popup"><?php _cp("Popup") ?></el-radio>
                            <el-radio label="modal"><?php _cp("Modal") ?></el-radio>
                        </el-radio-group>
                    </el-form-item>

                </el-tab-pane>


                <el-tab-pane label="Login page" name="login">

                    <el-form-item label="Enable Login">
                        <el-switch v-model="form.login.enable" active-text="<?php _cp('Enable') ?>"></el-switch>
                    </el-form-item>

                    <el-form-item label="Login SMS">
                        <el-row :gutter="0">
                            <el-col :style="styling_col_150">
                                <el-switch v-model="form.login.mode_sms"
                                           active-text="<?php _cp("Enable") ?>"></el-switch>
                            </el-col>
                            <el-col :span="12">
                                <el-input size="small" v-if="form.login.mode_sms"
                                          v-model="form.login.sms_button_text"></el-input>
                            </el-col>
                        </el-row>
                    </el-form-item>

                    <el-form-item label="Login Email">
                        <el-row :gutter="0">
                            <el-col :style="styling_col_150">
                                <el-switch v-model="form.login.mode_email"
                                           active-text="<?php _cp("Enable") ?>"></el-switch>
                            </el-col>
                            <el-col :span="12">
                                <el-input size="small" v-if="form.login.mode_email"
                                          v-model="form.login.email_button_text"></el-input>
                            </el-col>
                        </el-row>
                    </el-form-item>

                </el-tab-pane>


                <el-tab-pane label="WooCommerce" name="woo">
                    <?php if (class_exists("WooCommerce")) : ?>
                        <p><b><?php _cp("LOGIN FORM") ?></b></p>

                        <el-form-item label="Enable Login">
                            <el-switch v-model="form.woo.enable" active-text="<?php _cp('Enable') ?>"></el-switch>
                        </el-form-item>


                        <el-form-item label="Login SMS">
                            <el-row :gutter="0">
                                <el-col :style="styling_col_150">
                                    <el-switch v-model="form.woo.mode_sms"
                                               active-text="<?php _cp("Via SMS") ?>"></el-switch>
                                </el-col>
                                <el-col :span="12">
                                    <el-input v-if="form.woo.mode_sms" v-model="form.woo.sms_button_text"></el-input>
                                </el-col>
                            </el-row>
                        </el-form-item>

                        <el-form-item label="Login Email">
                            <el-row :gutter="0">
                                <el-col :style="styling_col_150">
                                    <el-switch v-model="form.woo.mode_email"
                                               active-text="<?php _cp("Via Email") ?>"></el-switch>
                                </el-col>
                                <el-col :span="12">
                                    <el-input v-if="form.woo.mode_email"
                                              v-model="form.woo.email_button_text"></el-input>
                                </el-col>
                            </el-row>
                        </el-form-item>

                        <hr>
                        <p><b><?php _cp("ORDER VERIFY") ?></b></p>
                        <el-form-item label="<?php _cp("Verify Order After Checkout") ?>">
                            <div>
                                <el-switch v-model="form.woo.thankyou_page"
                                           active-text="<?php _cp("Enable") ?>"></el-switch>
                            </div>

                            <el-switch
                                    v-if="form.woo.thankyou_page == true"
                                    v-model="form.woo.thankyou_page_autopopup"
                                    active-text="<?php _cp("Auto Open Verify Popup") ?>"></el-switch>

                            </el-form-item>

                        <el-form-item label="Action Show Button"
                                      v-if="form.woo.thankyou_page == true">
                            <el-select v-model="form.woo.thankyou_page_action" placeholder="Select">
                                <el-option
                                        v-for="item, key in actions_checkout"
                                        :key="key"
                                        :label="item"
                                        :value="key">
                                </el-option>
                            </el-select>
                        </el-form-item>

                        <el-form-item label="Status Verify Success" v-if="form.woo.thankyou_page == true">
                            <el-select v-model="form.woo.status_verify" placeholder="Select">
                                <el-option
                                        v-for="item, key in woo_status"
                                        :key="key"
                                        :label="item"
                                        :value="key">
                                </el-option>
                            </el-select>
                        </el-form-item>


                        <hr>
                        <p><b><?php _cp("VERIFY TO DOWNLOAD (Global)") ?></b></p>
                        <el-form-item label="Download With SMS">
                            <el-row :gutter="0">
                                <el-col :style="styling_col_150">
                                    <el-switch v-model="form.woo.download_sms"
                                               active-text="<?php _cp("Enable") ?>"></el-switch>
                                </el-col>
                                <el-col :span="12">
                                    <el-input
                                            placeholder="<?php _cp('Download with Phone') ?>"
                                            size="small" v-if="form.woo.download_sms"
                                            v-model="form.woo.download_sms_btn_text"></el-input>
                                </el-col>
                            </el-row>
                        </el-form-item>

                        <el-form-item label="Download With Email">
                            <el-row :gutter="0">
                                <el-col :style="styling_col_150">
                                    <el-switch v-model="form.woo.download_email"
                                               active-text="<?php _cp("Enable") ?>"></el-switch>
                                </el-col>
                                <el-col :span="12">
                                    <el-input
                                            placeholder="<?php _cp('Download with Email') ?>"
                                            size="small" v-if="form.woo.download_email"
                                            v-model="form.woo.download_email_btn_text"></el-input>
                                </el-col>
                            </el-row>
                        </el-form-item>

                        <el-form-item label="<?php _cp("Display Position") ?>">
                            <el-select v-model="form.woo.download_display" placeholder="Select">
                                <el-option value="0" label="<?php _cp("None") ?>"></el-option>
                                <el-option value="6" label="<?php _cp("After Title") ?>"></el-option>
                                <el-option value="11" label="<?php _cp("After Price") ?>"></el-option>
                                <el-option value="21" label="<?php _cp("After Excerpt") ?>"></el-option>
                                <el-option value="29" label="<?php _cp("Before Add to Cart Button") ?>"></el-option>
                                <el-option value="31" label="<?php _cp("After Add to Cart Button") ?>"></el-option>
                                <el-option value="41" label="<?php _cp("After Metadata") ?>"></el-option>
                                <el-option value="51" label="<?php _cp("After Sharing") ?>"></el-option>
                            </el-select>
                        </el-form-item>

                        <el-form-item label="Button Add To Cart">
                            <el-row :gutter="0">
                                <el-col :style="styling_col_150">
                                    <el-switch v-model="form.woo.download_hide_add_cart"
                                               active-text="<?php _cp("Hidden") ?>"></el-switch>
                                </el-col>
                            </el-row>
                        </el-form-item>

                    <?php else: ?>
                        <p class="cpotp-alert cpotp-danger"><?php _cp("Plugin WooCommerce  not activated!") ?></p>
                    <?php endif; ?>
                </el-tab-pane>

            </el-tabs>

            <div>
                <p>
                    <el-button native-type="submit" type="success"><?php _cp('Save change') ?></el-button>
                </p>
            </div>
        </el-form>
    </div>

</div>

<?php
$orderStatus = [];
if (function_exists('wc_get_order_statuses')) {
    $orderStatus = wc_get_order_statuses();
    $orderStatus = array_merge(['none' => __cp('None')], $orderStatus);
}
?>
<script>
    var appCpOTP = new Vue({
        el: '#appCpOTP',
        data: {
            tabActive: "general",
            loading: false,
            woo_status: <?php echo json_encode($orderStatus) ?>,
            actions_checkout : <?php echo json_encode(cpsmart_otp_woo::admin_get_action_page_after_checkout()) ?>,
            form: {
                app_id: '',
                app_secret: '',
                app_version: '',
                app_display: '',
                login: {
                    enable: true,
                    mode_sms: true,
                    mode_email: true,
                },
                woo: {
                    enable: true,
                    mode_sms: true,
                    mode_email: true,
                    sms_button_text: "",
                    email_button_text: "",
                    thankyou_page: true,
                    thankyou_page_autopopup: true,
                    thankyou_page_action: "",
                    status_verify: '',

                    download_sms: "",
                    download_sms_btn_text: "",
                    download_email: "",
                    download_email_btn_text: "",
                    download_display: "0",
                },
                contact7: {
                    enable: true,
                    mode_sms: true,
                    mode_email: true,
                }
            },

            styling_opts: {
                width_label: "150px"
            }
        },
        created: function () {
            this.form = <?php echo json_encode($cp_otp_options); ?>
        },

        computed: {
            styling_tab_header: function(){
                return "height: 820px";
            },
            styling_col_150: function () {
                return "width: 150px";
            }
        },

        methods: {
            saveForm: function (event) {
                event.preventDefault();
                var that = this;
                that.loading = true;
                jQuery.post('', {
                    CpOTP_options: this.form
                }, function (res) {
                    if (res.status == 200) {
                        that.$notify({
                            offset: 30,
                            type: "success",
                            title: 'Success',
                            message: 'Save Options success'
                        });

                        that.form = res.options;
                    }
                }).done(function () {
                    that.loading = false;
                });

            }
        }
    })
</script>