<?php

class cpsmart_otp_log
{
    const TABLE_LOG = "cpotp_logs";
    const TABLE_VERIFYED = "cpotp_item";
    const TABLE_DOWNLOAD = "cpotp_download";
    const DOWNLOAD_ACTIVE = 1;
    const DOWNLOAD_INACTIVE = 2;

    public static function get_log_table()
    {
        global $wpdb;
        return $wpdb->prefix . self::TABLE_LOG;
    }

    public static function get_verified_table()
    {
        global $wpdb;
        return $wpdb->prefix . self::TABLE_VERIFYED;
    }

    public static function get_download_table()
    {
        global $wpdb;
        return $wpdb->prefix . self::TABLE_DOWNLOAD;
    }

    public static function get_table_name()
    {
        return self::get_log_table();
    }

    private static function add_verified_item($phone, $phonePrefix, $email)
    {
        global $wpdb;

        $tableItem = self::get_verified_table();
        $data = [];

        if (!empty($phone)) {
            $data['phone'] = $phone;
        }
        if (!empty($phonePrefix)) {
            $data['phone_prefix'] = $phonePrefix;
        }
        if (!empty($email)) {
            $data['email'] = $email;
        }
        if (count($data) <= 0) {
            return false;
        }

        $sql = "SELECT * FROM $tableItem WHERE email = '{$email}' OR phone = '{$phone}' ";
        $old = $wpdb->get_row($sql);

        if ($old == null) {
            if (count($data) > 0) {
                $user = false;
                if (!empty($email)) {
                    $user = get_user_by('email', $email);
                }
                if (!$user && !empty($phone)) {
                    $user = get_user_by('login', str_replace('+', '', $phone));
                }

                if ($user) {
                    $data['user_id'] = $user->ID;

                    $sql = "SELECT * FROM $tableItem WHERE user_id = '{$user->ID}'";
                    $old = $wpdb->get_row($sql);
                }


                if ($old == null) {
                    $data['created_at'] = time();
                    return $wpdb->insert($tableItem, $data);
                } else {
                    return $wpdb->update($tableItem, $data, ['user_id' => $user->ID]);
                }
            } else {
                return false;
            }
        } else {
            $wpdb->update($tableItem, $data, [
                "id" => $old->id
            ]);

            return $old->id;
        }
    }


    public static function add_log_login($args)
    {
        $phone = isset($args['phone']) ? $args['phone'] : '';
        $email = isset($args['email']) ? $args['email'] : '';
        $form_name = isset($args['form_name']) ? $args['form_name'] : 'wp_login';
        $referralUrl = isset($args['referral']) ? $args['referral'] : '';
        $phone_prefix = isset($args['phone_prefix']) ? $args['phone_prefix'] : '';

        global $wpdb;
        $table_name = self::get_log_table();

        $data = [
            'form_name' => $form_name,
            'referral_url' => $referralUrl,
            'created_at' => time()
        ];

        $item_id = self::add_verified_item($phone, $phone_prefix, $email);

        if ($item_id > 0) {
            $data['item_id'] = $item_id;
            $wpdb->insert($table_name, $data);
        }
    }

    public static function add_log_cf7($args)
    {
        $phone = isset($args['phone']) ? $args['phone'] : '';
        $email = isset($args['email']) ? $args['email'] : '';
        $referralUrl = isset($args['referral']) ? $args['referral'] : '';
        $phone_prefix = isset($args['phone_prefix']) ? $args['phone_prefix'] : '';
        $user_id = isset($args['user_id']) ? $args['user_id'] : '';
        $object_id = isset($args['form_id']) ? $args['form_id'] : '';

        global $wpdb;
        $table_name = self::get_log_table();

        $data = [
            'form_name' => "Contact Form 7",
            'referral_url' => $referralUrl,
            'created_at' => time(),
            'object_id' => $object_id
        ];

        $item_id = self::add_verified_item($phone, $phone_prefix, $email);
        if ($item_id > 0) {
            $data['item_id'] = $item_id;
            $wpdb->insert($table_name, $data);
            return $wpdb->insert_id;
        } else {
            return '';
        }
    }

    public static function add_log_woo($args)
    {
        $phone = isset($args['phone']) ? $args['phone'] : '';
        $email = isset($args['email']) ? $args['email'] : '';
        $form_name = isset($args['form_name']) ? $args['form_name'] : '';
        $referralUrl = isset($args['referral']) ? $args['referral'] : '';
        $phone_prefix = isset($args['phone_prefix']) ? $args['phone_prefix'] : '';
        $user_id = isset($args['user_id']) ? $args['user_id'] : '';
        $object_id = isset($args['order_id']) ? $args['order_id'] : '';

        global $wpdb;
        $table_name = self::get_log_table();

        $data = [
            'form_name' => $form_name,
            'referral_url' => $referralUrl,
            'created_at' => time(),
            'object_id' => $object_id
        ];

        $item_id = self::add_verified_item($phone, $phone_prefix, $email);
        if ($item_id > 0) {
            $data['item_id'] = $item_id;

            $wpdb->insert($table_name, $data);
        }
    }


    public static function create_db()
    {
        global $wpdb;
        require_once(ABSPATH . 'wp-admin/includes/upgrade.php');


        $table_name = self::get_log_table();
        $itemTable = self::get_verified_table();
        $downloadTable = self::get_download_table();


        $sql = "CREATE TABLE $table_name ( 
              `id` INT(12) NOT NULL AUTO_INCREMENT ,
              `item_id` INT(12) NOT NULL,
              `object_id` INT(12) NULL DEFAULT NULL , 
              `referral_url` VARCHAR(255) NULL DEFAULT NULL , 
              `content` LONGTEXT NULL DEFAULT NULL , 
              `form_name` VARCHAR(255) NULL DEFAULT NULL , 
              `created_at` INT NOT NULL DEFAULT 0 , 
              PRIMARY KEY (`id`)) ENGINE = InnoDB;";

        $sqlTableItem = "
            CREATE TABLE $itemTable (
              `id` INT(12) NOT NULL AUTO_INCREMENT ,
              `phone` VARCHAR(20) NULL DEFAULT NULL , 
              `phone_prefix` VARCHAR(5) NULL DEFAULT NULL ,
              `user_id` INT(12) NULL DEFAULT NULL ,
              `email` VARCHAR(255) NULL DEFAULT NULL ,
              `created_at` INT NOT NULL DEFAULT 0 ,
              PRIMARY KEY (`id`)) ENGINE = InnoDB;";

        $sqlTableDownload = "CREATE TABLE $downloadTable (
              `id` int(11) NOT NULL,
              `token` varchar(255) NOT NULL,
              `files` varchar(255) NOT NULL,
              `object_id` int(11) NOT NULL,
              `phone` varchar(20) NULL DEFAULT NULL,
              `email` varchar(255) NULL DEFAULT NULL,
              `user_id` int(11) DEFAULT NULL,
              `limit` int(11) NOT NULL,
              `created_at` int(11) NOT NULL,
              `updated_at` int(11) NOT NULL,
              `count` int(11) NOT NULL,
              `status` int(11) NOT NULL,
              PRIMARY KEY (`id`),
              UNIQUE KEY `token` (`token`),
              UNIQUE KEY `object_id` (`object_id`,`phone`,`email`)
            ) ENGINE=InnoDB DEFAULT CHARSET=utf8;";

        dbDelta($sqlTableDownload);
        dbDelta($sqlTableItem);
        dbDelta($sql);
    }

    public static function find($params = [])
    {
        global $wpdb;

        $sql = "SELECT * FROM " . self::get_table_name();
        $query = [];
        if (isset($params['conditions'])) {
            foreach ($params['conditions'] as $key => $value) {
                $query[] = "{$key} $value";
            }
        }

        if (count($query) > 0) {
            $sql .= " WHERE ";
            $sql .= implode(" AND ", $query);
        }

        $sql .= " ORDER BY id DESC";


        if (isset($params['limit']) && $params['limit'] > 0) {
            $sql .= " LIMIT {$params['limit']}";
        }
        if (isset($params['offset']) && $params['offset'] > 0) {
            $sql .= " OFFSET {$params['offset']}";
        }

        return $wpdb->get_results($sql);
    }

    public static function cf7_check($phone, $email, $formId)
    {
        global $wpdb;
        $table_name = self::get_table_name();

        if (!empty($phone)) {
            $logCount = $wpdb->get_var("SELECT COUNT(*) FROM $table_name WHERE phone = '{$phone}'");
            $query = "AND phone = '{$phone}'";
        } elseif (!empty($email)) {
            $query = "AND email = '{$email}'";
        }

        $logCount = $wpdb->get_var("SELECT COUNT(*) FROM $table_name WHERE form_name = '" . cp_otp_cf7::FORM_NAME . "' AND object_id = {$formId} {$query}");


        if ($logCount == null || $logCount == 0) {
            return false;
        } else {
            return true;
        }
    }

    public static function update_log_cf7($dataSave)
    {
        global $wpdb;
        $table_name = self::get_table_name();

        $cpItem = isset($dataSave['cpotp_log_id']) ? $dataSave['cpotp_log_id'] : '';

        $wpdb->update(
            $table_name,
            [
                'content' => serialize($dataSave)
            ],
            array(
                'id' => $cpItem
            )
        );
    }

    public static function getDownLoadRow($object_id, $token, $phone, $email)
    {
        global $wpdb;

        $sql = "select * from " . self::get_download_table() . " where object_id='{$object_id}' AND token='{$token}' AND (phone='{$phone}' OR email='$email')";
        $row = $wpdb->get_row($sql);


        return $row;
    }
}
