<?php

class cpsmart_otp_templates
{
    public static function format_atts($atts)
    {
        $html = '';

        $prioritized_atts = array( 'type', 'name', 'value' );

        foreach ($prioritized_atts as $att) {
            if (isset($atts[$att])) {
                $value = trim($atts[$att]);
                $html .= sprintf(' %s="%s"', $att, esc_attr($value));
                unset($atts[$att]);
            }
        }

        foreach ($atts as $key => $value) {
            $key = strtolower(trim($key));

            if (! preg_match('/^[a-z_:][a-z_:.0-9-]*$/', $key)) {
                continue;
            }

            $value = trim($value);

            if ('' !== $value) {
                $html .= sprintf(' %s="%s"', $key, esc_attr($value));
            }
        }

        $html = trim($html);

        return $html;
    }


    public static function get_table_download_woocommerce(WC_Product $product)
    {
        $output = $contentTable = [];

        $downloads = $product->get_downloads();
        foreach ($downloads as $key => $each_download) {
            $url = admin_url('admin-ajax.php') . '?' . http_build_query([
                    'action' => 'cpotp_download_file',
                    'id' => $each_download['id'],
                    'product_id' => $product->get_id()
                ]);
            $url = esc_url($url);

            $contentTable[] = "<tr>
                <th>{$each_download['name']}</th>
                <td>
                    <a target='_blank' href='{$url}' class='button button-cpotp-download'>" . __cp('Download') . "</a> 
                </td>
            </tr>";
        }


        $output['html'][] = "<table class=\"woocommerce-table woocommerce-table--order-downloads shop_table shop_table_responsive\">";
        $output['html'][] = "<thead><th>" . __cp("File name") . "</th>";
        $output['html'][] = "<td>" . __cp("Download") . "</td></thead>";

        $output['html'][] = implode('', $contentTable);

        $output['html'][] = "</table>";
        $output['html'] = implode('', $output['html']);


        return $output['html'];
    }

    public static function page_error($message)
    {
        status_header(404, $message);
        die;
    }
}
