<?php

class cp_otp_page_setting
{
    public static function get_defaul_options()
    {
        return [
            "app_id" => '',
            "app_secret" => '',
            "app_version" => '',
            "app_display" => "popup",
            "login" => [
                "enable"=> true,
                "mode_sms"=> true,
                "sms_button_text" => __cp("Login via SMS"),
                "mode_email"=> false,
                "email_button_text" => __cp("Login via Email"),
            ],
            "woo"=> [
                "enable"=> true,
                "mode_sms"=> true,
                "mode_email"=> true,
                "sms_button_text" => __cp("Login via SMS"),
                "email_button_text" => __cp("Login via Email"),
                "thankyou_page" => true,
                "thankyou_page_action" => "",
                "thankyou_page_autopopup" => true,
                "status_verify" => "",

                "download_sms" => false,
                "download_sms_btn_text" => __cp("Download by Phone"),
                "download_email" => false,
                "download_email_btn_text" => __cp("Download by Email"),
                "download_display" => "0",
                "download_hide_add_cart" => true
            ],
            "contact7"=> [
                "enable"=> false,
                "mode_sms"=> true,
                "mode_email"=> true,
            ]
        ];
    }



    public static function get_options()
    {
        $cp_otp_options = get_option('CpOTP_data', self::get_defaul_options());
        return $cp_otp_options;
    }

    public static function general()
    {
        $cp_otp_options = self::get_options();

        include CPOTP_PATH . '/admin/partials/setting-page.php';
    }

    public static function save_options_general()
    {
        if (
            isset($_SERVER['HTTP_X_REQUESTED_WITH'])
            && $_SERVER['HTTP_X_REQUESTED_WITH'] === 'XMLHttpRequest'
            && isset($_POST['CpOTP_options'])
        ) {
            $CpOTP_options = $_POST['CpOTP_options'];
            $options_final = self::merge_array_option(self::get_defaul_options(), $CpOTP_options);

            update_option('CpOTP_data', $options_final);

            sleep(1.5);

            wp_send_json([
                "status" => 200,
                "message" => "Success.",
                "options" => $options_final
            ]);
        }
    }

    private static function merge_array_option($struct, $data)
    {
        foreach ($struct as $key => $value) {
            if (isset($data[$key])) {
                if (!is_array($value)) {
                    if (is_bool($value)) {
                        $struct[$key] = $data[$key] == 'true' ? true : false;
                    } else {
                        $struct[$key] = $data[$key];
                    }
                } else {
                    $struct[$key] = self::merge_array_option($struct[$key], $data[$key]);
                }
            }
        }

        return $struct;
    }


    /////Log list

    public static function logs()
    {
        global $wpdb;

        $limit = 20;

        $logType = \CastPlugin\CpCore::getRequest('log_type', ['strip_tags', 'trim'], 'all');
        $actionPage = \CastPlugin\CpCore::getRequest('action_page', ['strip_tags', 'trim'], 'logs');
        $paged = \CastPlugin\CpCore::getRequest('paged', ['int'], 1);

        $offset = ($paged - 1) * $limit;



        if ($actionPage == 'logs') {
            $sqlTotalLogs = "SELECT count(*) as count, `form_name` as name FROM `". cpsmart_otp_log::get_log_table() ."` GROUP BY `form_name`";
            $logsStatistic = $wpdb->get_results($sqlTotalLogs);
            $logsTotal = 0;
            foreach ($logsStatistic as $key => $item) {
                $logsTotal += (int)$item->count;
            }

            $sqlItems = "SELECT 
                            item.id, 
                            item.phone, 
                            item.email, 
                            item.user_id, 
                            logs.form_name, 
                            logs.content, 
                            logs.referral_url, 
                            logs.created_at, 
                            logs.object_id 
                        FROM `". cpsmart_otp_log::get_log_table() ."` as logs
                        LEFT JOIN `". cpsmart_otp_log::get_verified_table() ."` as item on `item`.`id` = `logs` .`item_id`";

            $queryItems = [];
            if ($logType != 'all') {
                $queryItems[] = " form_name = '{$logType}' ";
            }

            if (count($queryItems) > 0) {
                $sqlItems .= " WHERE " . implode(' AND ', $queryItems);
            }
            $sqlItems .= " ORDER BY logs.id DESC ";
            $sqlItems .= " LIMIT {$limit} OFFSET {$offset}";

            $items = $wpdb->get_results($sqlItems);
        } elseif ($actionPage == 'woo-download') {
            $sqlTotalResult = "SELECT count(*) FROM `". cpsmart_otp_log::get_download_table() ."`";
            $totalItems = $wpdb->get_var($sqlTotalResult);

            $sqlItems = "SELECT *
                        FROM `". cpsmart_otp_log::get_download_table() ."`";
            $sqlItems .= " ORDER BY id DESC ";
            $sqlItems .= " LIMIT {$limit} OFFSET {$offset}";
            $items = $wpdb->get_results($sqlItems);
        } elseif ($actionPage == 'verified') {
            $sqlTotalResult = "SELECT count(*) FROM `". cpsmart_otp_log::get_verified_table() ."`";
            $totalItems = $wpdb->get_var($sqlTotalResult);

            $sqlItems = "SELECT *
                        FROM `". cpsmart_otp_log::get_verified_table() ."`";
            $sqlItems .= " ORDER BY id DESC ";
            $sqlItems .= " LIMIT {$limit} OFFSET {$offset}";
            $items = $wpdb->get_results($sqlItems);
        }


        include CPOTP_PATH . '/admin/partials/logs-sms-verify.php';
    }
}
