<?php


class cp_otp_wp_login
{
    public function __construct()
    {
        add_action('woocommerce_login_form', [ $this, 'login_form' ]);
        add_action('login_form', [ $this, 'login_form' ]);
        add_action('woocommerce_login_form', [ $this, 'login_scripts' ]);
        add_action('login_head', [ $this, 'login_scripts' ]);
        add_action('admin_init', [ $this, 'check_user_can_register' ]);
    }

    public function login_form()
    {
        $cp_otp_options = cp_otp_page_setting::get_options();

        $allow_login_email = $allow_login_sms = false;

        if (isset($cp_otp_options['login']['mode_sms']) && $cp_otp_options['login']['mode_sms'] == true) {
            $allow_login_sms = true;
        }
        if (isset($cp_otp_options['login']['mode_email']) && $cp_otp_options['login']['mode_email'] == true) {
            $allow_login_email = true;
        }


        if (isset($cp_otp_options['login']['enable']) && $cp_otp_options['login']['enable'] == true) {
            include CPOTP_PATH . '/public/partials/cp-sms-login.php';
        }
    }

    public function login_scripts()
    {
        wp_enqueue_script('fb-account-kit');
        wp_enqueue_script('cpotp-process-login');

        wp_enqueue_style('fb-account-kit-style', CPOTP_PUBLIC . '/css/cp-otp-login.css');
    }

    public function check_user_can_register()
    {
        if (isset($_GET['page']) && $_GET['page'] == CPOTP_DASHBOARD_SLUG) {
            $cp_otp_options = cp_otp_page_setting::get_options();
            if (isset($cp_otp_options['login']['enable']) && $cp_otp_options['login']['enable'] == true) {
                if (!get_option('users_can_register')) {
                    $cp_core_notice = new \CastPlugin\CpAdminNotice();
                    $cp_core_notice->warning("You need check \"Anyone can register\" in Settings > General to auto create user on login via Smart OTP success");
                }
            }
        }
    }
}

new cp_otp_wp_login();
